Index: issm/trunk/src/c/classes/matrix/ElementMatrix.cpp
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementMatrix.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/matrix/ElementMatrix.cpp	(revision 27232)
@@ -162,5 +162,5 @@
 		pf->SetValues(fsize,this->fglobaldoflist,localvalues,ADD_VAL);
 
-		/*Free ressources:*/
+		/*Free resources:*/
 		xDelete<IssmDouble>(localvalues);
 	}
Index: issm/trunk/src/c/cores/ResetBoundaryConditions.cpp
===================================================================
--- issm/trunk/src/c/cores/ResetBoundaryConditions.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/ResetBoundaryConditions.cpp	(revision 27232)
@@ -25,5 +25,5 @@
 	UpdateDynamicConstraintsx(femmodel->constraints,femmodel->nodes,femmodel->parameters,yg);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete yg;
 }
Index: issm/trunk/src/c/cores/adgradient_core.cpp
===================================================================
--- issm/trunk/src/c/cores/adgradient_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/adgradient_core.cpp	(revision 27232)
@@ -168,5 +168,5 @@
 			if(VerboseAutodiff())_printf0_("   end ad core\n");
 
-			/* delete the allocated space for the parameters and free ressources:{{{*/
+			/* delete the allocated space for the parameters and Free resources:{{{*/
 			xDelete(anEDF_for_solverx_p->dp_x);
 			xDelete(anEDF_for_solverx_p->dp_X);
Index: issm/trunk/src/c/cores/control_core.cpp
===================================================================
--- issm/trunk/src/c/cores/control_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/control_core.cpp	(revision 27232)
@@ -107,5 +107,5 @@
 	}
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<int>(control_type);
 	xDelete<int>(maxiter);
@@ -189,5 +189,5 @@
 	_printf0_("\n");
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(XU);
 	xDelete<IssmDouble>(XL);
Index: issm/trunk/src/c/cores/dakota_core.cpp
===================================================================
--- issm/trunk/src/c/cores/dakota_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/dakota_core.cpp	(revision 27232)
@@ -228,5 +228,5 @@
 	OutputResultsx(femmodel);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	DakotaFree(&d_variables,&d_variables_descriptors,&responses_descriptors, d_numvariables, numresponsedescriptors);
 
Index: issm/trunk/src/c/cores/esa_core.cpp
===================================================================
--- issm/trunk/src/c/cores/esa_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/esa_core.cpp	(revision 27232)
@@ -106,5 +106,5 @@
 		if(solution_type==EsaSolutionEnum)femmodel->RequestedDependentsx();
 
-		/*Free ressources:*/	
+		/*Free resources:*/	
 		delete U_radial;
 		delete U_north;
Index: issm/trunk/src/c/cores/groundingline_core.cpp
===================================================================
--- issm/trunk/src/c/cores/groundingline_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/groundingline_core.cpp	(revision 27232)
@@ -40,5 +40,5 @@
 	if(save_results) femmodel->RequestedOutputsx(&femmodel->results,requested_outputs,numoutputs);
 
-	/*Free ressources:*/
+	/*Free resources:*/
    if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 
Index: issm/trunk/src/c/cores/hydrology_core.cpp
===================================================================
--- issm/trunk/src/c/cores/hydrology_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/hydrology_core.cpp	(revision 27232)
@@ -57,9 +57,9 @@
 		InputDuplicatex(femmodel,WatercolumnEnum,WaterColumnOldEnum);
 
-		/*grab tws from the hydrology.spcwatercolumn field input and update 
+		/*grab tws from the hydrology.spcwatercolumn field input and update
 		 * the solution with it:*/
 		Vector<IssmDouble>*  ug  = NULL;
 		GetVectorFromInputsx(&ug,femmodel,HydrologyTwsSpcEnum,VertexPIdEnum);
-		InputUpdateFromSolutionx(femmodel,ug); 
+		InputUpdateFromSolutionx(femmodel,ug);
 
 		/*solid earth considerations:*/
@@ -83,13 +83,17 @@
 		if(ThawedNodes>0){
 			/*check if we need sub steps*/
-			int        dtslices;
-			femmodel->parameters->FindParam(&dtslices,HydrologyStepsPerStepEnum);
-
-			if(dtslices>1){
-				int        substep, numaveragedinput, hydro_averaging;
-				IssmDouble global_time, subtime, yts;
+			int  dtslices;
+			bool sliceadapt;
+         bool conv_fail=false;
+         femmodel->parameters->FindParam(&dtslices,HydrologyStepsPerStepEnum);
+         femmodel->parameters->FindParam(&sliceadapt,HydrologyStepAdaptEnum);
+
+			if(dtslices>1 || sliceadapt){
+				int        step, substep, numaveragedinput, hydro_averaging, remainingslices;
+				IssmDouble global_time, subtime, yts, remainingtime, averagetime;
 				IssmDouble dt, subdt;
 
             femmodel->parameters->FindParam(&global_time,TimeEnum);
+				femmodel->parameters->FindParam(&step,StepEnum);
             femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
             femmodel->parameters->FindParam(&yts,ConstantsYtsEnum);
@@ -124,7 +128,9 @@
 				}
 				femmodel->InitTransientInputx(&transientinput[0],numaveragedinput);
+				averagetime=0;
 				while(substep<dtslices){ //loop on hydro dts
 					substep+=1;
 					subtime+=subdt;
+					averagetime+=subtime*subdt;
 					/*Setting substep time as global time*/
 					femmodel->parameters->SetParam(subtime,TimeEnum);
@@ -138,7 +144,32 @@
 					}
 					/*Proceed now to heads computations*/
-					solutionsequence_hydro_nonlinear(femmodel);
-               /*If we have a sub-timestep we store the substep inputs in a transient input here*/
-					femmodel->StackTransientInputonBasex(&substepinput[0],&transientinput[0],subtime,numaveragedinput);
+					solutionsequence_hydro_nonlinear(femmodel, &conv_fail);
+					if(conv_fail){
+                  /*convergence failed, we want to go back to the begining of the main step and increase the number of subslices*/
+                  /*First we get teh time and step counter back to the begining of the step that did not converge*/
+                  averagetime-=subtime*subdt;
+                  subtime-=subdt;
+                  substep-=1;
+                  /*compute the number of slice that are remaining and the time left in the timestep*/
+                  remainingslices=dtslices-substep;
+                  remainingtime=global_time-subtime;
+                  /*We double the number of remaining slices and compute their duration*/
+                  dtslices=dtslices-remainingslices+(2*remainingslices);
+                  subdt=remainingtime/(2*remainingslices);
+                  if(VerboseSolution())_printf0_("convergence failed for sub-step "<< substep <<" total number of slice is now "<< dtslices <<" for step "<<step<<"\n");
+                  if(VerboseSolution())_printf0_("next slice duration is "<< subdt/yts <<" years\n");
+                  conv_fail = false;  //re-initialize the control keyword
+                  if (dtslices>500){
+                     _error_("   We reached (" << dtslices << ") which exceeds the hard limit of 500");
+                  }
+
+                  femmodel->parameters->SetParam(subdt,TimesteppingTimeStepEnum);
+                  femmodel->parameters->SetParam(subtime,TimeEnum);
+
+               }
+               else{
+						/*If we have a sub-timestep we store the substep inputs in a transient input here*/
+						femmodel->StackTransientInputonBasex(&substepinput[0],&transientinput[0],subtime,numaveragedinput);
+					}
 				}
 				/*averaging the stack*/
@@ -147,4 +178,8 @@
 				femmodel->parameters->SetParam(dt,TimesteppingTimeStepEnum);
 				femmodel->parameters->SetParam(global_time,TimeEnum);
+				if(save_results){
+               femmodel->results->AddResult(new GenericExternalResult<int>(femmodel->results->Size()+1,HydrologySubstepsEnum,dtslices,step,global_time));
+               femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,HydrologySubTimeEnum,(averagetime/dt)/yts,step,global_time));
+            }
 			}
 			else{
@@ -156,5 +191,5 @@
 				/*Proceed now to heads computations*/
 				if(VerboseSolution()) _printf0_("   computing water heads\n");
-				solutionsequence_hydro_nonlinear(femmodel);
+				solutionsequence_hydro_nonlinear(femmodel, &conv_fail);
 				/*If no substeps are present we want to duplicate the results for coupling purposes*/
 				InputDuplicatex(femmodel,SedimentHeadSubstepEnum,SedimentHeadEnum);
@@ -236,5 +271,5 @@
 		}
 	}
-	/*Free ressources:*/
+	/*Free resources:*/
 	if(numoutputs){
 		for(int i=0;i<numoutputs;i++){
Index: issm/trunk/src/c/cores/masstransport_core.cpp
===================================================================
--- issm/trunk/src/c/cores/masstransport_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/masstransport_core.cpp	(revision 27232)
@@ -97,5 +97,5 @@
 	if(solution_type==MasstransportSolutionEnum)femmodel->RequestedDependentsx();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 
Index: issm/trunk/src/c/cores/oceantransport_core.cpp
===================================================================
--- issm/trunk/src/c/cores/oceantransport_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/oceantransport_core.cpp	(revision 27232)
@@ -52,5 +52,5 @@
 	femmodel->profiler->Stop(OCEANTRANSPORTCORE);
 
-	/*free ressources:*/
+	/*Free resources:*/
 	delete ug;
 
Index: issm/trunk/src/c/cores/sampling_core.cpp
===================================================================
--- issm/trunk/src/c/cores/sampling_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/sampling_core.cpp	(revision 27232)
@@ -69,5 +69,5 @@
 	if(solution_type==SamplingSolutionEnum)femmodel->RequestedDependentsx();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 
Index: issm/trunk/src/c/cores/sealevelchange_core.cpp
===================================================================
--- issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 27232)
@@ -29,4 +29,5 @@
 void ivins_deformation_core(FemModel* femmodel);
 IssmDouble* CombineLoads(IssmDouble* load,IssmDouble* subload,FemModel* femmodel, SealevelGeometry* slgeom,int loadtype,int nel);
+void slc_geometry_cleanup(SealevelGeometry* slgeom, FemModel* femmodel);
 /*}}}*/
 
@@ -81,4 +82,7 @@
 	/*End profiler*/
 	femmodel->profiler->Stop(SLRCORE);
+
+	/*Free resources:*/
+	slc_geometry_cleanup(slgeom, femmodel);
 }
 /*}}}*/
@@ -143,5 +147,5 @@
 	}
 
-	/*Free ressources:*/	
+	/*Free resources:*/	
 	delete bedrock; delete bedrock_rate;
 	delete geoid; delete geoid_rate;
@@ -358,5 +362,5 @@
 		//Conserve ocean mass: 
 		oceanaverage=SealevelloadsOceanAverage(loads, oceanareas,subelementoceanareas, totaloceanarea);
-		ConserveOceanMass(femmodel,loads,barycontrib->Total()/totaloceanarea - oceanaverage,slgeom);
+		ConserveOceanMass(femmodel,loads,barycontrib->Total()/totaloceanarea -oceanaverage,slgeom);
 
 		//broadcast sea level loads 
@@ -364,9 +368,14 @@
 
 		//convergence?
-		if(slcconvergence(loads->vsealevelloads,oldsealevelloads,eps_rel,eps_abs))break;
+		if(slcconvergence(loads->vsealevelloads,oldsealevelloads,eps_rel,eps_abs)){
+			delete oldsealevelloads; break;
+		}
 
 		//early return?
-		if(iterations>=max_nonlinear_iterations)break;
+		if(iterations>=max_nonlinear_iterations){
+			delete oldsealevelloads; break;
+		}
 		iterations++;
+		delete oldsealevelloads;
 	}
 
@@ -388,5 +397,5 @@
 	if(planethasocean){
 		if (!sealevelloading){ //we haven't done so before, so we need to compute the ocean average and area
-			loads->sealevelloads=NULL; //needed to trigger the calculation of areas
+			if(loads->sealevelloads)xDelete<IssmDouble>(loads->sealevelloads); loads->sealevelloads=NULL; //needed to trigger the calculation of areas
 			/*retrieve sea level average  and ocean area:*/
 			for(Object* & object : femmodel->elements->objects){
@@ -430,4 +439,9 @@
 	}
 
+	/*Free resources:*/
+	delete loads;
+	delete subelementoceanareas;
+	delete oceanareas;
+	xDelete<IssmDouble>(sealevelpercpu); 
 }
 /*}}}*/
@@ -487,5 +501,5 @@
 	InputUpdateFromVectorx(femmodel,sealevel,SealevelEnum,VertexSIdEnum);	
 
-	/*Free ressources:*/	
+	/*Free resources:*/	
 	delete sealevel;
 	delete deltadsl;
@@ -557,5 +571,5 @@
 	femmodel->inputs->AXPY(1,BedGRDEnum,BedEnum);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<IssmDouble>(xx);
 	xDelete<IssmDouble>(yy);
@@ -574,4 +588,5 @@
 	IssmDouble* areae  = NULL;
 	int  nel;
+	int* lids;
 	int  grdmodel=0;
 
@@ -589,8 +604,21 @@
 	ElementCoordinatesx(&xxe,&yye,&zze,&areae,femmodel->elements);
 
+
+	/*Compute element ids, used to speed up computations in convolution phase:{{{*/
+	lids=xNew<int>(femmodel->vertices->Size());
+
+	for(Object* & object : femmodel->elements->objects){
+		Element*   element=xDynamicCast<Element*>(object);
+		for(int i=0;i<3;i++){
+			lids[element->vertices[i]->lid]=element->lid;
+		}
+	}
+
+	/*}}}*/
+
 	/*Run sealevel geometry routine in elements:*/
 	for(Object* & object : femmodel->elements->objects){
 		Element*   element=xDynamicCast<Element*>(object);
-		element->SealevelchangeGeometryInitial(xxe,yye,zze,areae);
+		element->SealevelchangeGeometryInitial(xxe,yye,zze,areae,lids);
 	}
 
@@ -607,4 +635,10 @@
 	#endif
 
+	xDelete<IssmDouble>(xxe);
+	xDelete<IssmDouble>(yye);
+	xDelete<IssmDouble>(zze);
+	xDelete<IssmDouble>(areae);
+	xDelete(lids);
+
 	return;
 
@@ -623,9 +657,11 @@
 	int nel;
 	int  grdmodel=0;
+	int isgrd=0;
 	SealevelGeometry* slgeom=NULL;
 
 	/*early return?:*/
 	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
-	if(grdmodel==IvinsEnum) return NULL;
+	femmodel->parameters->FindParam(&isgrd,SolidearthSettingsGRDEnum);
+	if(grdmodel!=ElasticEnum || !isgrd) return NULL;
 
 	/*retrieve parameters:*/
@@ -673,7 +709,31 @@
 	femmodel->parameters->AddObject(new DoubleVecParam(AreaeEnum,areae,nel));
 
+	/*Free resources:*/
+	xDelete<IssmDouble>(xxe);
+	xDelete<IssmDouble>(yye);
+	xDelete<IssmDouble>(zze);
+	xDelete<IssmDouble>(areae);
+
 	return slgeom;
 
 }/*}}}*/
+void slc_geometry_cleanup(SealevelGeometry* slgeom, FemModel* femmodel){  /*{{{*/
+	int  grdmodel=0;
+	int isgrd=0;
+	int horiz=0;
+
+	/*early return?:*/
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	femmodel->parameters->FindParam(&isgrd,SolidearthSettingsGRDEnum);
+	femmodel->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+	if(grdmodel!=ElasticEnum || !isgrd) return;
+
+	for (int l=0;l<SLGEOM_NUMLOADS;l++){
+		femmodel->inputs->DeleteInput(slgeom->AlphaIndexEnum(l));
+		if (horiz) femmodel->inputs->DeleteInput(slgeom->AzimuthIndexEnum(l));
+	}
+
+	delete slgeom;
+} /*}}}*/
 
 /*subroutines:*/
@@ -731,7 +791,4 @@
 	Vector<IssmDouble>* vsealevelloadsvolume=loads->vsealevelloads->Duplicate();
 	Vector<IssmDouble>* vsubsealevelloadsvolume=loads->vsubsealevelloads->Duplicate();
-
-	vsealevelloadsvolume->PointwiseMult(loads->vsealevelloads,oceanareas);
-	vsubsealevelloadsvolume->PointwiseMult(loads->vsubsealevelloads,suboceanareas); 
 
 	vsealevelloadsvolume->Sum(&sealevelloadsaverage);
@@ -870,5 +927,10 @@
 			xDelete<IssmDouble>(m3interp);
 		}
-	}
+		xDelete<IssmDouble>(viscoustimes);
+		xDelete<IssmDouble>(viscouspolarmotion);
+	}
+	xDelete<IssmDouble>(pmtf_col);
+	xDelete<IssmDouble>(pmtf_ortho);
+	xDelete<IssmDouble>(pmtf_z);
 
 } /*}}}*/
@@ -935,4 +997,5 @@
 		/*free allocations:*/
 		xDelete<IssmDouble>(viscoustimes);
+		if (rotation) 	xDelete<IssmDouble>(viscouspolarmotion);
 	}
 
@@ -1097,5 +1160,5 @@
 	/*}}}*/
 
-	/*Free ressources:{{{*/
+	/*Free resources:{{{*/
 	if(forcings){
 		for(int i=0;i<nummodels-1;i++){
@@ -1209,5 +1272,5 @@
 	/*}}}*/
 
-	/*Free ressources:{{{*/
+	/*Free resources:{{{*/
 	if(forcingglobal)xDelete<IssmDouble>(forcingglobal);
 	if(forcing)xDelete<IssmDouble>(forcing);
Index: issm/trunk/src/c/cores/smb_core.cpp
===================================================================
--- issm/trunk/src/c/cores/smb_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/smb_core.cpp	(revision 27232)
@@ -108,5 +108,5 @@
 	if(solution_type==SmbSolutionEnum)femmodel->RequestedDependentsx();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 
Index: issm/trunk/src/c/cores/steadystate_core.cpp
===================================================================
--- issm/trunk/src/c/cores/steadystate_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/steadystate_core.cpp	(revision 27232)
@@ -81,5 +81,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete tg_old;
 	delete ug_old;
Index: issm/trunk/src/c/cores/stressbalance_core.cpp
===================================================================
--- issm/trunk/src/c/cores/stressbalance_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/stressbalance_core.cpp	(revision 27232)
@@ -98,5 +98,5 @@
 	if(solution_type==StressbalanceSolutionEnum && !control_analysis)femmodel->RequestedDependentsx();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 
Index: issm/trunk/src/c/cores/thermal_core.cpp
===================================================================
--- issm/trunk/src/c/cores/thermal_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/thermal_core.cpp	(revision 27232)
@@ -53,5 +53,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 
Index: issm/trunk/src/c/cores/transient_core.cpp
===================================================================
--- issm/trunk/src/c/cores/transient_core.cpp	(revision 27035)
+++ issm/trunk/src/c/cores/transient_core.cpp	(revision 27232)
@@ -130,5 +130,5 @@
 
 	/*parameters: */
-	bool isstressbalance,ismasstransport,isoceantransport,issmb,isthermal,isgroundingline,isesa,issampling;;
+	bool isstressbalance,ismasstransport,isage,isoceantransport,issmb,isthermal,isgroundingline,isesa,issampling;
 	bool isslc,ismovingfront,isdamageevolution,ishydrology,isoceancoupling,isstochasticforcing,save_results;
 	int  step,sb_coupling_frequency;
@@ -142,4 +142,5 @@
 	femmodel->parameters->FindParam(&isstressbalance,TransientIsstressbalanceEnum);
 	femmodel->parameters->FindParam(&ismasstransport,TransientIsmasstransportEnum);
+	femmodel->parameters->FindParam(&isage,TransientIsageEnum);
 	femmodel->parameters->FindParam(&isoceantransport,TransientIsoceantransportEnum);
 	femmodel->parameters->FindParam(&issmb,TransientIssmbEnum);
@@ -249,5 +250,5 @@
 		femmodel->RequestedOutputsx(&femmodel->results,requested_outputs,numoutputs,save_results);
 
-		/*Free ressources:*/
+		/*Free resources:*/
 		for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);
 	}
Index: issm/trunk/src/c/datastructures/DataSet.cpp
===================================================================
--- issm/trunk/src/c/datastructures/DataSet.cpp	(revision 27035)
+++ issm/trunk/src/c/datastructures/DataSet.cpp	(revision 27232)
@@ -266,4 +266,9 @@
 				this->AddObject(cfsurf);
 			}
+			else if(obj_enum==CfdragcoeffabsgradEnum){
+				Cfdragcoeffabsgrad* cfdragcoeff=new Cfdragcoeffabsgrad();
+				cfdragcoeff->Marshall(marshallhandle);
+				this->AddObject(cfdragcoeff);
+			}
 			else if(obj_enum==MassfluxatgateEnum){
 				Massfluxatgate<IssmDouble>* massfluxgate=new Massfluxatgate<IssmDouble>();
Index: issm/trunk/src/c/main/issm_ocean.cpp
===================================================================
--- issm/trunk/src/c/main/issm_ocean.cpp	(revision 27035)
+++ issm/trunk/src/c/main/issm_ocean.cpp	(revision 27232)
@@ -62,5 +62,5 @@
 	ExceptionTrapEnd();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 
 	/*Return unix success: */
Index: issm/trunk/src/c/main/issm_slc.cpp
===================================================================
--- issm/trunk/src/c/main/issm_slc.cpp	(revision 27035)
+++ issm/trunk/src/c/main/issm_slc.cpp	(revision 27232)
@@ -122,5 +122,5 @@
 	ExceptionTrapEnd();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(commsizes);
 	for(int i=0;i<nummodels;i++){
Index: issm/trunk/src/c/main/kriging.cpp
===================================================================
--- issm/trunk/src/c/main/kriging.cpp	(revision 27035)
+++ issm/trunk/src/c/main/kriging.cpp	(revision 27232)
@@ -68,5 +68,5 @@
 	WriteLockFile(lockfilename);
 
-	/*Free ressources */
+	/*Free resources: */
 	xDelete<char>(lockfilename);
 	xDelete<char>(binfilename);
Index: issm/trunk/src/c/modules/AllocateSystemMatricesx/AllocateSystemMatricesx.cpp
===================================================================
--- issm/trunk/src/c/modules/AllocateSystemMatricesx/AllocateSystemMatricesx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/AllocateSystemMatricesx/AllocateSystemMatricesx.cpp	(revision 27232)
@@ -77,5 +77,5 @@
 	}
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<char>(toolkittype);
 
Index: issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp
===================================================================
--- issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 27232)
@@ -45,5 +45,5 @@
 	average=vec_average->ToMPISerial();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete partition_contributions;
 	delete partition_areas;
Index: issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.cpp
===================================================================
--- issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.cpp	(revision 27232)
@@ -37,5 +37,5 @@
 	IssmDouble* areae=vareae->ToMPISerial();
 
-	/*Free ressources: */
+	/*Free resources: */
 	delete vxe;
 	delete vye;
@@ -79,5 +79,5 @@
 	IssmDouble* areae=vareae->ToMPISerial();
 
-	/*Free ressources: */
+	/*Free resources: */
 	delete vlonge;
 	delete vlate;
Index: issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 27232)
@@ -109,5 +109,5 @@
 	vector=vec_vector->ToMPISerial();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete vec_vector;
 
@@ -126,5 +126,5 @@
 	vector=vec_vector->ToMPISerial();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete vec_vector;
 
Index: issm/trunk/src/c/modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp
===================================================================
--- issm/trunk/src/c/modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp	(revision 27232)
@@ -106,5 +106,5 @@
 	*pdwidt=reCast<IssmDouble>(blocks_.aswokm_dwdt);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<IssmPDouble>(blockt_time);
 	xDelete<IssmPDouble>(blockt_bi);
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.cpp
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 27232)
@@ -89,5 +89,5 @@
 	IssmDouble* gradient=vec_gradient->ToMPISerial();
 
-	/*Free ressources and assign output pointer*/
+	/*Free resources: and assign output pointer*/
 	delete vec_gradient;
 	*pgradient=gradient;
Index: issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 27232)
@@ -177,5 +177,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete vec_phi;
 	xDelete<IssmDouble>(elements_neighboring_floatingce);
Index: issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 27232)
@@ -145,5 +145,5 @@
 	femmodel->results->AddResult(new GenericExternalResult<IssmPDouble*>(femmodel->results->Size()+1,"uq_variables",variables,numdakotavariables,1,1,0));
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	for(i=0;i<variable_partitions_num;i++){
 		IssmDouble* matrix=variable_partitions[i];
Index: issm/trunk/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp	(revision 27232)
@@ -12,5 +12,5 @@
 	InputUpdateFromVectorDakotax(femmodel,serial_vector,name, type);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<double>(serial_vector);
 }
Index: issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 27232)
@@ -589,5 +589,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(times);
 	xDelete<IssmDouble>(values);
@@ -723,5 +723,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(times);
 	xDelete<IssmDouble>(values);
Index: issm/trunk/src/c/modules/MeshPartitionx/MeshPartitionx.h
===================================================================
--- issm/trunk/src/c/modules/MeshPartitionx/MeshPartitionx.h	(revision 27035)
+++ issm/trunk/src/c/modules/MeshPartitionx/MeshPartitionx.h	(revision 27232)
@@ -112,5 +112,5 @@
 	*pnpart=npart;
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<int>(index);
 	xDelete<int>(epart2d);
Index: issm/trunk/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp
===================================================================
--- issm/trunk/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp	(revision 27232)
@@ -109,5 +109,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete segments_dataset;
 
Index: issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp	(revision 27232)
@@ -69,5 +69,5 @@
 		parameters->AddObject(theAdolcEDF_p);
 
-		/*Free ressources: */
+		/*Free resources: */
 		xDelete<char>(options);
 		/*}}}*/
@@ -96,5 +96,5 @@
 							_error_("solver type not supported yet!");
 		}
-		/*Free ressources: */
+		/*Free resources: */
 		xDelete<char>(options);
 		#endif
@@ -159,5 +159,5 @@
 			}
 
-			/*Free ressources:*/
+			/*Free resources:*/
 			for(i=0;i<num_dependent_objects;i++){
 				char* string=names[i]; xDelete<char>(string);
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 27232)
@@ -223,4 +223,5 @@
 											{
 												Tria* tria= xDynamicCast<Tria*>(element);
+												if(tria->hmaterial)delete tria->hmaterial; 
 												tria->hmaterial=NULL;
 											}
@@ -290,5 +291,5 @@
 				}
 			}
-			//Free ressources:
+			//Free resources:
 			xDelete<int>(nature);
 			break;
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateOutputDefinitions.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateOutputDefinitions.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateOutputDefinitions.cpp	(revision 27232)
@@ -50,5 +50,5 @@
 					output_definitions->AddObject(new Massfluxatgate<IssmDouble>(gatenames[j],StringToEnumx(gatedefinitionstrings[j]),gatesegments_M[j],gatesegments[j]));
 				}
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<numgates;j++){
 					char*       string  = gatenames[j];             xDelete<char>(string);
@@ -126,5 +126,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<nummisfits;j++){
 					char* string=NULL;
@@ -217,5 +217,5 @@
 				}
 
-				  /*Free ressources:*/
+				  /*Free resources:*/
 				for(j=0;j<num_cfsurfacesquares;j++){
 					char* string=NULL;
@@ -288,5 +288,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<num_cfdragcoeffabsgrads;j++){
 					char* string=NULL;
@@ -374,5 +374,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<num_cfsurfacelogvels;j++){
 					char* string=NULL;
@@ -463,5 +463,5 @@
 				}
 
-				  /*Free ressources:*/
+				  /*Free resources:*/
 				for(j=0;j<num_cflevelsetmisfits;j++){
 					char* string=NULL;
@@ -512,5 +512,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<numnodalvalues;j++){
 					char* string=NULL;
@@ -546,5 +546,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<nummasscons;j++){
 					char* string=NULL;
@@ -589,5 +589,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<num;j++){
 					char* string=NULL;
@@ -629,5 +629,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<numout;j++){
 					char* string=NULL;
@@ -707,5 +707,5 @@
 				xDelete<char*>(cost_functions);
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				for(j=0;j<numout;j++){
 					xDelete<char>(ncf_name_s[j]);
@@ -744,5 +744,5 @@
 	parameters->AddObject(new DataSetParam(OutputdefinitionEnum,output_definitions));
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete output_definitions;
 	xDelete<int>(output_definition_enums);
